#include <stdlib.h>
#include <stdbool.h>
#import "async.h"
#import "utils.h"

static void * gc_consumer(void * ptr);
static void * heap_consumer(void * ptr);

void run_threads(JavaVM * javaVM) {
	nbb_init(&gc_buffer);
	nbb_init(&heap_buffer);

	pthread_t gc_consumer_t;
	pthread_create(&gc_consumer_t, NULL, gc_consumer, (void *) javaVM);
	// TODO matej Run only if flag
	pthread_t heap_consumer_t;
	pthread_create(&heap_consumer_t, NULL, heap_consumer, (void *) javaVM);
}

static void * gc_consumer(void * ptr) {
	JNIEnv * jniEnv = getJniEnv((JavaVM *) ptr);
	if (jniEnv == NULL) {
		fprintf(stderr, "ERROR: jniEnv not found\n");
		abort();
	}
	jclass class = (*jniEnv)->FindClass(jniEnv,
			"ch/usi/inf/sape/ld/LeakDetector");
	jmethodID method = (*jniEnv)->GetStaticMethodID(jniEnv, class,
			"objectFreed", "(Ljava/lang/Object;)V");
	jlong buff[NBB_BUFFER_SIZE];
	while (true) {
		nbb_read_buffer(&gc_buffer, buff);
		int i;
		for (i = 0; i < NBB_BUFFER_SIZE; i++) {
			jobject obj = (jobject) (void*) buff[i];
			// TODO matej Hide under a flag
//			(*jniEnv)->CallStaticVoidMethod(jniEnv, class, method, obj);
			(*jniEnv)->DeleteGlobalRef(jniEnv, obj);
		}
	}
}

static void * heap_consumer(void * ptr) {
	JNIEnv * jniEnv = getJniEnv((JavaVM *) ptr);
	if (jniEnv == NULL) {
		fprintf(stderr, "ERROR: jniEnv not found\n");
		abort();
	}
	jclass class = (*jniEnv)->FindClass(jniEnv,
			"ch/usi/inf/sape/ld/LeakDetector");
	jmethodID method = (*jniEnv)->GetStaticMethodID(jniEnv, class, "enumerated",
			"(Ljava/lang/Object;)V");
	jlong buff[NBB_BUFFER_SIZE];
	while (true) {
		nbb_read_buffer(&heap_buffer, buff);
		int i;
		for (i = 0; i < NBB_BUFFER_SIZE; i++) {
			jobject obj = (jobject) (void*) buff[i];
			(*jniEnv)->CallStaticVoidMethod(jniEnv, class, method, obj);
		}
	}
}
