#include <jni.h>
#include <pthread.h>

#ifndef NBB_H_
#define NBB_H_

#define NBB_BUFFER_SIZE 1024

typedef struct OneBuffer {

	jlong elems[NBB_BUFFER_SIZE];

	struct OneBuffer * next;

	// first free element
	int start;

} one_buffer_t;

typedef one_buffer_t * one_buffer_ref;

typedef struct NonBlockingBuffer {

	// buffer that will be read from
	one_buffer_ref last;

	// buffer that will be written to
	one_buffer_ref first;

	pthread_mutex_t lock;
	pthread_cond_t full;

} nbb_t;

typedef nbb_t * nbbref;

void nbb_init(const nbbref nbb);

void nbb_write(const nbbref nbb, const jlong elem);

void nbb_read_buffer(const nbbref nbb, jlong * buffer);

#endif
