package ch.usi.inf.sape.ld;

import org.objectweb.asm.tree.AbstractInsnNode;

public class LeakDetectorProvenance {

  private boolean initialized = false;

  private final AbstractInsnNode location;

  public LeakDetectorProvenance(final AbstractInsnNode location) {
    this.location = location;
  }

  public boolean isInitialized() {
    return initialized;
  }

  public void setInitialized(final boolean initialized) {
    this.initialized = initialized;
  }

  public AbstractInsnNode getLocation() {
    return location;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + (initialized ? 1231 : 1237);
    result = prime * result + (location == null ? 0 : location.hashCode());
    return result;
  }

  @Override
  public boolean equals(final Object obj) {
    if (this == obj) {
      return true;
    }
    if (obj == null) {
      return false;
    }
    if (!(obj instanceof LeakDetectorProvenance)) {
      return false;
    }
    final LeakDetectorProvenance other = (LeakDetectorProvenance) obj;
    if (initialized != other.initialized) {
      return false;
    }
    if (location == null) {
      if (other.location != null) {
        return false;
      }
    }
    return location == other.location;
  }

  @Override
  public String toString() {
    return initialized ? "I " : "U " + location.toString();
  }
}