package ch.usi.inf.sape.ld;

import java.util.HashSet;
import java.util.Set;

import org.objectweb.asm.Type;
import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.analysis.BasicValue;

public class LeakDetectorValue extends BasicValue {

  private final Set<LeakDetectorProvenance> provenance = new HashSet<LeakDetectorProvenance>();

  private AbstractInsnNode initializer;

  public LeakDetectorValue(final Type type) {
    super(type);
  }

  public LeakDetectorValue merge(final LeakDetectorValue w) {
    if (provenance != w.provenance) {
      provenance.addAll(w.provenance);
    }
    return this;
  }

  public Set<LeakDetectorProvenance> getProvenance() {
    return provenance;
  }

  public AbstractInsnNode getInitializer() {
    return initializer;
  }

  public void setInitializer(final AbstractInsnNode initializer) {
    this.initializer = initializer;
  }

  @Override
  public String toString() {
    return provenance.toString();
  }

}
